import 'package:osam/osam.dart';

import 'state.dart';

abstract class ICounter {
  Future<int> increment(int value);
}

class CounterUseCase {
  final AppState _appState;
  final ICounter _counterRepo;

  CounterUseCase(this._counterRepo, this._appState);

  Future<void> increment() async {
    final lastValue = _appState.counter.number.value;
    final newValue = await _counterRepo.increment(lastValue);
    _appState.counter.number.value = newValue;
  }

  ValueStream<int> get numberValue => _appState.counter.number.valueStream;
}
