import 'package:osam/osam.dart';

class PresentersProvider extends StatefulWidget {
  final Widget child;
  final List<Presenter> presenters;

  const PresentersProvider({Key key, this.presenters = const [], this.child}) : super(key: key);

  @override
  _PresentersProviderState createState() => _PresentersProviderState();
}

class _PresentersProviderState extends State<PresentersProvider> with AfterLayoutMixin {
  @override
  Widget build(BuildContext context) {
    return Container();
  }

  @override
  void afterFirstLayout(BuildContext context) {}

  @override
  void dispose() {
    super.dispose();
  }
}

class _OsamPageRoute extends CupertinoPageRoute {
  final VoidCallback transitionCallback;

  _OsamPageRoute(
    this.transitionCallback, {
    @required WidgetBuilder builder,
    String title,
    RouteSettings settings,
    bool maintainState = true,
    bool fullscreenDialog = false,
  }) : super(
            builder: builder,
            title: title,
            settings: settings,
            maintainState: maintainState,
            fullscreenDialog: fullscreenDialog);

  @override
  Widget buildPage(
      BuildContext context, Animation<double> animation, Animation<double> secondaryAnimation) {
    // ignore: omit_local_variable_types
    final Widget child = builder(context);
    final Widget result = Semantics(
      scopesRoute: true,
      explicitChildNodes: true,
      child: child,
    );
    assert(() {
      return true;
    }());
    transitionCallback();
    return result;
  }
}

class OsamIgnorePointer extends StatefulWidget {
  final Widget child;

  const OsamIgnorePointer({Key key, this.child}) : super(key: key);

  @override
  _OsamIgnorePointerState createState() => _OsamIgnorePointerState();
}

class _OsamIgnorePointerState extends State<OsamIgnorePointer> {
  @override
  Widget build(BuildContext context) {
    return Stack(
      children: <Widget>[widget.child, Container()],
    );
  }
}
